#
# Copyright 2017.  Cumulus Networks, Inc.
#
import os
import subprocess
import cumulus.platform
import cumulus.cpld
import cumulus.ledup
import cumulus.sunit
import cumulus.sfp
import cumulus.sensors
from cumulus.platforms.accton_wedge100_32x import *


class Wedge100SCoreTemp(cumulus.sensors.Temp_Unit):
    description = cumulus.sensors.Temp_Unit.intel_cpu_sensor_name
    driver_path = '/sys/devices/platform/coretemp.0'
    temp_max = 82
    temp_crit = 104
    no_shutdown = True


class Wedge100STemp1(Wedge100SCoreTemp):
    name = 'Temp1'
    description = 'Physical id 0'
    driver_hwmon = ['temp1']


class Wedge100STemp2(Wedge100SCoreTemp):
    name = 'Temp2'
    description = 'Core 1'
    driver_hwmon = ['temp2']


class Wedge100STemp3(Wedge100SCoreTemp):
    name = 'Temp3'
    description = 'Core 2'
    driver_hwmon = ['temp3']


class Wedge100STemp4(Wedge100Temp5):
    name = 'Temp4'


class Wedge100STemp5(Wedge100Temp6):
    name = 'Temp5'


class Wedge100STemp6(Wedge100Temp7):
    name = 'Temp6'


class Wedge100STemp7(Wedge100Temp8):
    name = 'Temp7'


class Wedge100STemp8(Wedge100Temp9):
    name = 'Temp8'


class Wedge100STemp9(Wedge100Temp10):
    name = 'Temp9'


class Wedge100STemp10(Wedge100Temp11):
    name = 'Temp10'


class Wedge100STemp11(Wedge100Temp12):
    name = 'Temp11'


class Wedge100STemp12(Wedge100Temp13):
    name = 'Temp12'


class Wedge100SPSU(Wedge100PSU):
    cpld_path = '/sys/bus/i2c/devices/1-0032'


class Wedge100SPSU1(Wedge100SPSU):
    name = 'PSU1'
    psu_num = 1
    cpld_hwmon = ['psu_pwr1']


class Wedge100SPSU2(Wedge100SPSU):
    name = 'PSU2'
    psu_num = 2
    cpld_hwmon = ['psu_pwr2']


class Wedge100SSensors():
    units = (Wedge100STemp1(),
             Wedge100STemp2(),
             Wedge100STemp3(),
             Wedge100STemp4(),
             Wedge100STemp5(),
             Wedge100STemp6(),
             Wedge100STemp7(),
             Wedge100STemp8(),
             Wedge100STemp9(),
             Wedge100STemp10(),
             Wedge100STemp11(),
             Wedge100STemp12(),
             Wedge100Fan1(),
             Wedge100Fan2(),
             Wedge100Fan3(),
             Wedge100Fan4(),
             Wedge100Fan5(),
             Wedge100Fan6(),
             Wedge100Fan7(),
             Wedge100Fan8(),
             Wedge100Fan9(),
             Wedge100Fan10(),
             Wedge100SPSU1(),
             Wedge100SPSU2(),
            )


class Wedge100S(cumulus.platform.Platform):
    name = 'accton,wedge100s_32x'
    chip = cumulus.platform.TomahawkChip()
    switch = Wedge100Switch(chip)
    cpld = None
    statusleds = None
    pwms = None
    sensors = Wedge100SSensors()
    bmc = Wedge100BMC()


Platform = Wedge100S
